#ifndef BASIC_WINDOW_H
#define BASIC_WINDOW_H


class CBasicWindow {
protected:
	HWND m_hwnd;
	struct {
		int Left,Top;
		int Width,Height;
	} m_WindowPosition;
	bool CreateBasicWindow(HWND hwndParent,DWORD Style,DWORD ExStyle,int ID,
						LPCTSTR pszClassName,LPCTSTR pszText,HINSTANCE hinst);
	void OnDestroy();
public:
	CBasicWindow();
	virtual ~CBasicWindow();
	virtual bool Create(HWND hwndParent,DWORD Style,DWORD ExStyle)=0;
	void Destroy();
	void SetPosition(int Left,int Top,int Width,int Height);
	void GetPosition(int *pLeft,int *pTop,int *pWidth,int *pHeight) const;
	void GetPosition(RECT *pPosition) const;
	void SetVisible(bool fVisible);
	bool GetVisible() const;
	HWND GetHandle() { return m_hwnd; }
	bool Invalidate(bool fErase=true);
	bool Update();
	bool MoveToMonitorInside();
};


#endif
